;##################################################################
; DIALOGAPP
; Original Author - Unknown.
; Modified by Shooter.
;
; This sample demonstrates the use of two Dialog Buttons, and each
; button changes the text of a single Static Text.
;##################################################################

#include "DialogBox.Inc"
#include "windows.h"
#include "winuser.h"

.DATA
	hInst				DD 	0
	mys					MYSTRUCT <>
	frect				RECT <>
	EditBoxStr1			db 50 dup ?
	NwBtnStr1			db 'D-OH!!!',0
	NwBtnStr2			db 'Niiice.',0
	ClearStr			db '',0
	hBmp1        		DD   0
	hBmp2        		DD   0
	hBmp3        		DD   0
	PicSel				db	 ?
;##################################################################

.CODE

Start:
	INVOKE GetModuleHandle, 0
	MOV [hInst],EAX
	INVOKE DialogBoxParam,[hInst],1000,0,ADDR DlgProc,0
	INVOKE ExitProcess,0

DlgProc FRAME hwnd,uMsg,wParam,lParam

	MOV EAX,[uMsg]
WMINITDIALOG:
		CMP EAX,WM_INITDIALOG
		JNE >WMCOMMAND
ADDICON:
		INVOKE LoadImage, [hInst], 100, IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR
		INVOKE SendMessage, [hwnd], WM_SETICON,ICON_SMALL, eax
		INVOKE LoadBitmap,[hInst], 101
		MOV    [hBmp1], EAX
		INVOKE LoadBitmap,[hInst], 102
		MOV    [hBmp2], EAX
		INVOKE SendDlgItemMessage,[hwnd],1013,STM_SETIMAGE, IMAGE_BITMAP, [hBmp1]
		Mov B[PicSel],2
		JMP >EXIT

WMCOMMAND:
		CMP EAX,WM_COMMAND
		JNE >WMCLOSE
Text1_Enter:
		MOV EAX, [wParam]
		CMP EAX, 1011
		JNE >Button1_Click
		INVOKE GetDlgItemText,[hwnd],1008,OFFSET EditBoxStr1,50
		INVOKE SendDlgItemMessage,[hwnd],1010, WM_SETTEXT, 0, OFFSET EditBoxStr1 + NULL
		JMP >EXIT
Button1_Click:		;D-OH!!!
		MOV EAX,[wParam]
		CMP EAX,1001
		JNE >Button2_Click
		INVOKE SendDlgItemMessage,[hwnd],1003,WM_SETTEXT, 0, OFFSET NwBtnStr1
		JMP >EXIT
Button2_Click:		;Niiice.
		MOV EAX,[wParam]
		CMP EAX,1002
		JNE >Button3_Click
		INVOKE SendDlgItemMessage,[hwnd],1003,WM_SETTEXT, 0, OFFSET NwBtnStr2
		JMP >EXIT
Button3_Click:		;Clear Text
		MOV EAX,[wParam]
		CMP EAX,1006
		JNE >Button4_Click
		INVOKE SendDlgItemMessage,[hwnd],1003,WM_SETTEXT, 0, OFFSET ClearStr
		JMP >EXIT
Button4_Click:		;Swap
		MOV EAX,[wParam]
		CMP EAX,1014
		JNE >Quit
		CMP B[PicSel],1
		JNE >.Pic2
		INVOKE SendDlgItemMessage,[hwnd],1013,STM_SETIMAGE, IMAGE_BITMAP, [hBmp1]
		Mov B[PicSel],2
		JMP >EXIT
	.Pic2
		INVOKE SendDlgItemMessage,[hwnd],1013,STM_SETIMAGE, IMAGE_BITMAP, [hBmp2]
		Mov B[PicSel],1
		JMP >EXIT
Quit:	
		MOV EAX,[wParam]
		CMP EAX,1005
		JNE >WMCLOSE
		INVOKE EndDialog,[hwnd],0
		JMP >EXIT		
WMCLOSE:
		CMP EAX,WM_CLOSE
		JNE >DEFPROC
		INVOKE EndDialog,[hwnd],0
DEFPROC:
		mov EAX,FALSE
		RET
EXIT:

	MOV EAX, TRUE
	RET
DlgProc ENDF
